VERSION 5.00
Begin VB.Form frmPacker 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Packer by The trick"
   ClientHeight    =   1500
   ClientLeft      =   150
   ClientTop       =   765
   ClientWidth     =   6525
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   1500
   ScaleWidth      =   6525
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdRun 
      Caption         =   "Run"
      Height          =   390
      Left            =   5250
      TabIndex        =   8
      Top             =   975
      Width           =   1200
   End
   Begin VB.ComboBox cboBits 
      Height          =   315
      ItemData        =   "frmPacker.frx":0000
      Left            =   1830
      List            =   "frmPacker.frx":001C
      Style           =   2  'Dropdown List
      TabIndex        =   7
      Top             =   1035
      Width           =   3270
   End
   Begin VB.CommandButton cmdContainer 
      Caption         =   "..."
      Height          =   390
      Left            =   5250
      TabIndex        =   4
      Top             =   525
      Width           =   1200
   End
   Begin VB.TextBox txtContainer 
      Height          =   345
      Left            =   1830
      TabIndex        =   3
      Top             =   570
      Width           =   3270
   End
   Begin VB.CommandButton cmdSource 
      Caption         =   "..."
      Height          =   390
      Left            =   5250
      TabIndex        =   1
      Top             =   60
      Width           =   1200
   End
   Begin VB.TextBox txtSource 
      Height          =   345
      Left            =   1830
      TabIndex        =   0
      Top             =   105
      Width           =   3270
   End
   Begin VB.Label lblLabel 
      Caption         =   "Bitness:"
      Height          =   255
      Index           =   2
      Left            =   135
      TabIndex        =   6
      Top             =   1080
      Width           =   1620
   End
   Begin VB.Label lblLabel 
      Caption         =   "Container:"
      Height          =   255
      Index           =   1
      Left            =   135
      TabIndex        =   5
      Top             =   615
      Width           =   1620
   End
   Begin VB.Label lblLabel 
      Caption         =   "Source:"
      Height          =   255
      Index           =   0
      Left            =   135
      TabIndex        =   2
      Top             =   150
      Width           =   1620
   End
   Begin VB.Menu mnuFile 
      Caption         =   "File"
      Begin VB.Menu mnuOpenSource 
         Caption         =   "Open source..."
      End
      Begin VB.Menu mnuOpenContainer 
         Caption         =   "Open container..."
      End
      Begin VB.Menu mnuSep 
         Caption         =   "-"
      End
      Begin VB.Menu mnuExit 
         Caption         =   "Exit"
      End
   End
   Begin VB.Menu mnuMode 
      Caption         =   "Mode"
      Begin VB.Menu mnuUnpacker 
         Caption         =   "Unpacker"
      End
      Begin VB.Menu mnuPacker 
         Caption         =   "Packer"
         Checked         =   -1  'True
      End
   End
End
Attribute VB_Name = "frmPacker"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' Wave file steganography packer/unpacker.
' frmPacker.frm - packer module.
'  Krivous Anatolii Anatolevich (The trick), 2015

Option Explicit

Private Declare Sub CopyMemory _
                    Lib "kernel32" _
                    Alias "RtlMoveMemory" ( _
                    ByRef Destination As Any, _
                    ByRef Source As Any, _
                    ByVal Length As Long)

' // Open the file container
Private Sub cmdContainer_Click()
    Dim f As String
    ' // Get open file name
    f = ShowOpen(Me.Hwnd, "Wave PCM 16 bit" & vbNullChar & "*.wav")
    ' // If success
    If Len(f) Then
        ' // Put path to textbox
        txtContainer.Text = f
    End If
    
End Sub

' // Open the source file
Private Sub cmdSource_Click()
    Dim f As String
    
    f = ShowOpen(Me.Hwnd, "*.*")
    
    If Len(f) Then
        txtSource.Text = f
    End If
    
End Sub

' // Launch packing
Private Sub cmdRun_Click()
    Dim fNum    As Long:    Dim Ln      As Long:    Dim i       As Long
    Dim N       As Long:    Dim bits    As Long:    Dim Title   As String
    Dim Fle()   As Byte:    Dim Dat()   As Byte:    Dim Pat     As Long
    Dim Mask()  As Integer: Dim Div()   As Long:    Dim Cyc     As Long
    Dim Value   As Long
    
    If MsgBox("Rewrite?", vbExclamation Or vbYesNo) = vbNo Then Exit Sub
    ' // Get the bitness
    bits = cboBits.ListIndex
    ' // Set the error handler
    On Error GoTo ErrorOpenSource
    fNum = FreeFile
    ' // Open the source file
    Open txtSource.Text For Binary As fNum
    ' // Get the file size
    Ln = LOF(fNum)
    ' // Allocate the buffer
    ReDim Fle(Ln - 1)
    ' // Read the file to the buffer
    Get fNum, , Fle()
    ' // Close the file
    Close fNum
    ' // Disable the error handler
    On Error GoTo 0
    ' // Try to read the wave file
    If Not modWaveFile.ReadWaveFile(txtContainer.Text) Then Exit Sub
    ' // Get the file title
    Title = GetFileTitle(txtSource.Text) & vbNullChar
    ' // Allocate the buffer with the file title and the size of the file
    ReDim Dat(4 + Len(Title) + Ln)
    ' // Copy the size
    CopyMemory Dat(0), Ln, 4
    ' // Copy the file title
    CopyMemory Dat(4), ByVal Title, Len(Title)
    ' // Copy the data of the file
    CopyMemory Dat(4 + Len(Title)), Fle(0), Ln
    
    Erase Fle()
    ' // Calculate the minimum size of the wav-file for storing the needed data.
    i = (-Int(-(Ln + 4 + Len(Title)) / (bits + 1))) * 8
    If i > UBound(modWaveFile.WaveData) + 1 Then
        MsgBox "Size of the wave-file isn't enough for storing the data."
        Exit Sub
    End If
    ' // Fill the arrays of mask and dividers
    ' // Masks and diveders - 8 bit
    ReDim Mask(7):  ReDim Div(7)
    ' // 2 ^ 1 (1 shift)
    N = 2
    For i = 0 To 7
        ' // It is the number in order to obtain the necessary shift when it'll divide
        Div(i) = N
        ' // It is the mask that clears the necessary bits
        Mask(i) = -N
        N = N * 2
    Next
    i = 0: N = 0
    Pat = Dat(i)
    ' // File cycle
    Do
        ' // Extract the needed bits
        Value = Pat And (Not Mask(bits))
        ' // Shift it to right
        Pat = Pat \ Div(bits)
        ' // Add the bit offset
        Cyc = Cyc + (bits + 1)
        
        If Cyc > 7 Then
            ' // Get remainder
            Cyc = (Cyc And 7)
            ' // Next byte
            i = i + 1
            
            If i > UBound(Dat) Then
                ' // Done
                Exit Do
            End If
            
            Pat = Dat(i)
            
            ' // Align
            If Cyc Then
                ' // Extract the nedded bits
                Value = (Value Or Pat * Div(bits - Cyc)) And (Not Mask(bits))
                ' // Shift by the remainder value
                Pat = Pat \ Div(Cyc - 1)
            End If
        End If
        ' // Set bits to output buffer
        modWaveFile.WaveData(N) = (modWaveFile.WaveData(N) And Mask(bits)) Or Value
        N = N + 1
    Loop
    
    fNum = FreeFile
    ' // Open wave file and store data to there
    Open txtContainer.Text For Binary As fNum
    Seek fNum, modWaveFile.Offset + 1
    Put fNum, , modWaveFile.WaveData()
    Close fNum
    
    Exit Sub
    
ErrorOpenSource:
    MsgBox "Error opening of the source file"
    
End Sub

Private Sub Form_Load()
    ' // Default bitness
    cboBits.ListIndex = 2
End Sub

' // Retrieve file title
Private Function GetFileTitle( _
                 ByRef Path As String) As String
    Dim L As Long, p As Long
    
    L = InStrRev(Path, "\")
    p = Len(Path) + 1
    If p > L Then
        L = IIf(L = 0, 1, L + 1)
        GetFileTitle = Mid$(Path, L, p - L)
    ElseIf p = L Then
        GetFileTitle = Path
    Else
        GetFileTitle = Mid$(Path, L + 1)
    End If
    
End Function

' // Menu handlers
Private Sub mnuExit_Click()
    Unload Me
End Sub

Private Sub mnuOpenContainer_Click()
    cmdContainer_Click
End Sub

Private Sub mnuOpenSource_Click()
    cmdSource_Click
End Sub

Private Sub mnuUnpacker_Click()
    Unload Me
    frmUnpacker.Show
End Sub
